#!/usr/bin/python3
# -*- coding: utf-8 -*-


import os, sys, termios, tty, time, random
from math import sin, cos, tan, sqrt
from time import sleep

########################################################################################
def berechneflugbahn(cow, xmin, xmax, ymin, ymax, startwinkel, startgeschwindigkeit, starthoehe):
    x = 0
    y = x**2
    # in scala the resulting coordinates will be returned
    scala = []
    erde = 9.81
    mond = 1.6
    jupiter = 24
    gravitation = erde
    startwinkel = startwinkel * deg2rad
    cowlength = len(cow) + 1

    # Calculate time of flight
    flugdauer = startgeschwindigkeit * sin(startwinkel) / gravitation
    schlafdauer = flugdauer / xmax
    # Calculate maximum height
    hoehe = 0.5 * gravitation * flugdauer**2 + starthoehe

    # calculate length of flight
    wurfweite = (
        startgeschwindigkeit
        * cos(startwinkel)
        * (startgeschwindigkeit * sin(startwinkel) + sqrt(startgeschwindigkeit**2 * sin(startwinkel) ** 2 + 2 * gravitation * starthoehe))
    ) / gravitation

    # cowlength is 2, if cow is an UTF8-Icon, otherwise 1
    for x in range(xmin, xsteps - 1, cowlength):
        # the formula, which generates the y position for the corresponding x, shamelessly ripped from some schoolbook and modified.
        y = (-(gravitation / (2 * startgeschwindigkeit**2 * cos(startwinkel) ** 2)) * x**2) + (tan(startwinkel) * x + starthoehe)

        # Ensure, that nothing has to be drawn outside the viewport
        if y <= ymax and y >= ymin:
            # Stash away the coordinates into scala, which will be returned
            scala += [x, int((y * 100 + 50) / 100)]
        else:
            scala += [0, 0]

        xold = x

    return scala


#############################################################################################
# berechneflugbahn(cow, xmin, xmax, ymin, ymax, startwinkel, startgeschwindigkeit, starthoehe):

# set position of cursor
def curpos(x, y):
    print("\033[%d;%dH" % (ymax - y, x), end="", flush=True)


# Randomly choose a cow
cows = "🐵🐒🦍🦧🐕🐯🦝🐩🐅🐴🐎🦄🦌🐗🐂🐃🐄🐪🐫🦙🦒🐹🦘🦡🐧🕊️ 🦅🦆🦉🐍🦎🐊🦜🦚🦩🐲🐉🦕"
cowlistlength = len(cows)
cow = cows[random.randint(0, cowlistlength - 1)]
# pi is not defined by default
pi = 3.1416
deg2rad = pi / 180

# Needed: find our screensize. We are in textmode here
termsize_xy = os.get_terminal_size()

### I m p o r t a n t   p a r a m e t e r s ###

# X-Resolution of the display
xmax = termsize_xy[0] - 1
xsteps = xmax
ymax = termsize_xy[1]
ymin = 0
xmin = 0
startwinkel = 34
startgeschwindigkeit = 31
starthoehe = 0
###

# needed for erasing ol position
xold = xmin
yold = ymin
x = xmin
y = xmin

# Call the function, which calculates the coordinates)
ergebnis = berechneflugbahn(cow, xmin, xmax, ymin, ymax, startwinkel, startgeschwindigkeit, starthoehe)

# here we draw the cow
for count in range(xmin, len(ergebnis), 2):
    xold, yold = x, y
    x, y = ergebnis[count], ergebnis[count + 1]
    curpos(x, y)
    print(cow, end="")
    curpos(xold, yold)
    print(".",end="")
bla = input("CR please...")
